module Utils where
import Char
import List
import Maybe

type FMap a b = [(a,b)]
idf = []
appf f a = fromJust (lookup a f)
appf' f d a = fromMaybe d (lookup a f)

sepby c [] = []
sepby c (x:xs) = x ++ rest xs
     where rest [] = []
           rest (_:_) = c ++ sepby c xs

-- A nice definition, but not quite as lazy as the above
-- sepby c [] = []
-- sepby c xs = foldr1 step xs
--              where step xs ys = xs ++ c ++ ys

stringToInt = foldl step 0 . map digToInt
              where step a n = a*10 +n
                    digToInt d = ord d - ord '0'

posin xs x = (justhead . filter ((==x) . fst)) (zip xs [0..])
             where justhead [] = Nothing
                   justhead ((_,n):_) = Just n

subseteq x y  = all (flip elem y) x

seteq x y = subseteq x y && subseteq y x

subseq [] x = True
subseq (a:x) [] = False
subseq (a:x) (b:y) = if a==b then subseq x y else subseq (a:x) y

subsplus = tail . foldr step [[]]
           where step x xs = xs ++ map (x:) xs

collect :: Eq a => [(a,b)] -> [(a,[b])]
collect [] = []
collect ((a,l):x) = (a,l:ls):collect z
                    where (y,z) = splitWith ((==a).fst) x
                          ls = map snd y

splitWith :: (a -> Bool) -> [a] -> ([a],[a])
splitWith p [] = ([],[])
splitWith p (a:x) = if p a then (a:y,z) else (y,a:z)
                    where (y,z) = splitWith p x



segsplus :: [a] -> [([a],Int,Int)]
segsplus x = [ (z,i,j) | (y,i) <- zip (tails x) [0..], 
                              (z,j) <- zip (tail (inits y)) [i+1..]]

splits :: [a] -> [([a],[a])]
splits x = zip (inits x) (tails x)

{-
tails [] = [[]]
tails (a:x) = (a:x):tails x

inits [] = [[]]
inits (a:x) = []:map (a:) (inits x)
-}

