// EffectFactory.h: interface for the CEffectFactory class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EFFECTFACTORY_H__9741E4E7_6016_48B5_B273_A812E6C92697__INCLUDED_)
#define AFX_EFFECTFACTORY_H__9741E4E7_6016_48B5_B273_A812E6C92697__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Effect.h"
#include "PerfData.h"

class CEffectFactory  
{
public:
	CEffectFactory(int *pDisplayPasses, double *pMaxJitter, CComBSTR docURL);
	virtual ~CEffectFactory();

    CEffect* OpenEffect(HWND hWndParent, REFCLSID clsid, PTSTR progID, CPerfData* pData);
    CEffect* OpenEffect(HWND hWndParent, LPCTSTR fName, CPerfData* pData, LPTSTR& pEffectName);

    void SetMainHWND(HWND hWnd) { m_hWndMain = hWnd; }
    void SetDocumentURL(CComBSTR docURL) { m_docURL = docURL; }

private:
    HFONT       m_hFont;
    HWND        m_hWndMain;
    CComBSTR    m_docURL;
    int*        m_pDisplayPasses;
    double*     m_pMaxJitter;
};

#endif // !defined(AFX_EFFECTFACTORY_H__9741E4E7_6016_48B5_B273_A812E6C92697__INCLUDED_)
