/*
 * A file selector control - an edit box together with
 * an OpenFile dialog box (activated via a button.)
 */


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "stdafx.h"
#include "Box.h"
#include "Button.h"
#include "EditBox.h"

//
// ID used in WM_COMMANDs sent upwards to indicate that the
// file selection has changed.
//
#define FS_CHANGED  2


class CFileSelector : public CBox
{
public:

    CFileSelector();

    virtual ~CFileSelector();

    // Set the filter categories to use in the Open-File dialog.
    //
    // Copies the filter string, so resp. for freeing that string
    // doesn't transfer over to the CFileSelector object.
    void SetFilter(LPCTSTR f, unsigned int len);

    HWND Create
		( HWND     hWndParent
		, LPCTSTR  label
		, LPCTSTR  defValue
		, int nWidth, int nHeight
		, int selectorID
		);

    BEGIN_MSG_MAP(CFileSelector)
        MESSAGE_HANDLER(WM_GETTEXT, OnGetText)
        COMMAND_CODE_HANDLER(BN_CLICKED, OnClick)
        COMMAND_CODE_HANDLER(EN_CHANGE, OnChange)
        CHAIN_MSG_MAP(CBox)
    END_MSG_MAP()

    LRESULT OnGetText(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
    LRESULT OnClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
    LRESULT OnChange(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

    void SetFileName(LPCTSTR str);

private:
    CEditBox* m_edit;
    CBtn*     m_btn;
    LPTSTR    m_filter;

};